# -*- coding: cp1252 -*-

# InterfaceIMU_3D est bas sur sf9domahrs par Doug Weibel et Jose Julio:
# http://code.google.com/p/sf9domahrs/

# sf9domahrs est bas sur ArduIMU v1.5 par Jordi Munoz, William Premerlani, Jose
# Julio and Doug Weibel:
# http://code.google.com/p/ardu-imu/

# InterfaceIMU_3D est un logiciel libre ; vous pouvez la redistribuer ou
# la modifier suivant les termes de la Licence Gnrale Publique Limite
# GNU telle que publie par la Free Software Foundation ; soit la
# version 3 de la License, soit ( votre gr) toute version ultrieure.
# Ce script est distribu dans lespoir quil sera utile, mais
# SANS AUCUNE GARANTIE : sans mme la garantie implicite de
# COMMERCIALISABILIT ou dADQUATION  UN OBJECTIF PARTICULIER. Consultez
# la Licence Gnrale Publique Limite pour plus de dtails.
# Vous devriez avoir reu une copie de la Licence Gnrale Publique Limite
# GNU avec ce scriptque ; si ce nest pas le cas, crivez  la :
# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.
################################################################################

# Ce script ncessite Python 2.7 et les modules VPython, paramiko et crypto
# - Vpython 6.05 (http://www.vpython.org/) 
# - Crypto (https://pypi.python.org/pypi/pycrypto)
# - Paramiko (https://pypi.python.org/pypi/paramiko/1.10.1) 

from visual import *
import string
import math
import paramiko
import socket
from time import time

HOST = "192.168.0.199"
PORT = 5000
LOGIN = "root"
PASSWORD = "admin"


def ProduitVectoriel(a, b):
    c = [0, 0, 0]
    c = [a[1] * b[2] - a[2] * b[1],
         a[2] * b[0] - a[0] * b[2],
         a[0] * b[1] - a[1] * b[0]]

    return c


def ProduitScalaire(a, b):
    op = 0
    for i in range(3):
        op = op + a[i] * b[i]

    return op


def ProduitVecteurParScalaire(v, a):
    c = [0, 0, 0]
    for i in range(3):
        c[i] = v[i] * a

    return c


def SommeVecteurs(a, b):
    c = [0, 0, 0]
    for i in range(3):
        c[i] = a[i] + b[i]

    return c


def MultiplicationMatrices(a, b):
    op = [0, 0, 0]
    mat = [[0, 0, 0], [0, 0, 0], [0, 0, 0]]
    for i in range(3):
        for j in range(3):
            for k in range(3):
                op[k] = a[i][k] * b[k][j]

            mat[i][j] = op[0] + op[1] + op[2]
    return mat


def linesplit(socket):
    done = False

    try:
        buff = socket.recv(1024)
        erreur_buff = False
    except:
        erreur_buff = True
        done = True
        pass

    while not done:
        if "\n" in buff:
            (line, buff) = buff.split("\n", 1)
            yield line + "\n"
        else:

            try:
                more = socket.recv(1024)
            except:
                break
            if not more:
                done = True
            else:
                buff = buff + more

    if not erreur_buff:
        if buff:
            yield buff


deg2rad = 3.141592 / 180.0
GRAVITY = 9.81
Kp_ROLLPITCH = 0 * 0.02
Ki_ROLLPITCH = 0 * 0.00002
Kp_YAW = 1.2
Ki_YAW = 0.00002
G_Dt = 0.02


# Main scene
scene = display(title="Carambola-Box - Orientation dans l'espace")
scene.range = (1.2, 1.2, 1.2)
scene.forward = (1, 0, -0.25)
scene.up = (0, 0, 1)

# Second scene (Roll, Pitch, Yaw)
scene2 = display(title="Carambola-Box - Orientation dans l'espace", x=0, y=0, width=500, height=200, center=(0, 0, 0), background=(0, 0, 0))
scene2.range = (1, 1, 1)
scene.width = 500
scene.y = 200

scene2.select()
#Roll, Pitch, Yaw
cil_roll = cylinder(pos=(-0.4, 0, 0), axis=(0.2, 0, 0), radius=0.01, color=color.red)
cil_roll2 = cylinder(pos=(-0.4, 0, 0), axis=(-0.2, 0, 0), radius=0.01, color=color.red)
cil_pitch = cylinder(pos=(0.1, 0, 0), axis=(0.2, 0, 0), radius=0.01, color=color.green)
cil_pitch2 = cylinder(pos=(0.1, 0, 0), axis=(-0.2, 0, 0), radius=0.01, color=color.green)
arrow_course = arrow(pos=(0.6, 0, 0), color=color.cyan, axis=(-0.2, 0, 0), shaftwidth=0.02, fixedwidth=1)

#Roll, Pitch, Yaw labels
label(pos=(-0.4, 0.3, 0), text="Roulis", box=0, opacity=0)
label(pos=(0.1, 0.3, 0), text="Tangage", box=0, opacity=0)
label(pos=(0.55, 0.3, 0), text="Lacet", box=0, opacity=0)
label(pos=(0.6, 0.22, 0), text="N", box=0, opacity=0, color=color.yellow)
label(pos=(0.6, -0.22, 0), text="S", box=0, opacity=0, color=color.yellow)
label(pos=(0.38, 0, 0), text="W", box=0, opacity=0, color=color.yellow)
label(pos=(0.82, 0, 0), text="E", box=0, opacity=0, color=color.yellow)
label(pos=(0.75, 0.15, 0), height=7, text="NE", box=0, color=color.yellow)
label(pos=(0.45, 0.15, 0), height=7, text="NW", box=0, color=color.yellow)
label(pos=(0.75, -0.15, 0), height=7, text="SE", box=0, color=color.yellow)
label(pos=(0.45, -0.15, 0), height=7, text="SW", box=0, color=color.yellow)

L1 = label(pos=(-0.4, 0.22, 0), text="-", box=0, opacity=0)
L2 = label(pos=(0.1, 0.22, 0), text="-", box=0, opacity=0)
L3 = label(pos=(0.7, 0.3, 0), text="-", box=0, opacity=0)

# Main scene objects
scene.select()
# Reference axis (x, y, z)
arrow(color=color.green, axis=(1, 0, 0), shaftwidth=0.02, fixedwidth=1)
arrow(color=color.green, axis=(0, -1, 0), shaftwidth=0.02, fixedwidth=1)
arrow(color=color.green, axis=(0, 0, -1), shaftwidth=0.02, fixedwidth=1)
# labels
label(pos=(0, 0, 0.8), text="Carambola-Box - Orientation dans l'espace", box=0, opacity=0)
label(pos=(1, 0, 0), text="X", box=0, opacity=0)
label(pos=(0, -1, 0), text="Y", box=0, opacity=0)
label(pos=(0, 0, -1), text="Z", box=0, opacity=0)
# IMU object
platform = box(length=1, height=0.05, width=1, color=color.blue)
p_line = box(length=1, height=0.08, width=0.1, color=color.yellow)
plat_arrow = arrow(color=color.green, axis=(1, 0, 0),  shaftwidth=0.06, fixedwidth=1)


roll = 0
pitch = 0
yaw = 0


Accel_Vector = [0, 0, 0]
Gyro_Vector = [0, 0, 0]
Omega_Vector = [0, 0, 0]
Omega_P = [0, 0, 0]
Omega_I = [0, 0, 0]
Omega = [0, 0, 0]
Update_Matrix = [[0, 0, 0], [0, 0, 0], [0, 0, 0]]
DCM_Matrix = [[1, 0, 0], [0, 1, 0], [0, 0, 1]]

ssh = paramiko.SSHClient()
ssh.set_missing_host_key_policy(paramiko.AutoAddPolicy())
ssh.connect(HOST, username=LOGIN, password=PASSWORD)
ssh.exec_command("python /root/IMU/Python/CalibrationIMU.py")
ssh.exec_command("python /root/IMU/Python/TelemetrieIMU_noTime.py")

s = socket.create_connection((HOST, PORT))
s.setblocking(0)

time_old = time()
words = ['0', '0', '0', '0', '0', '0']

while 1:
    rate(150)
    line = linesplit(s)

    for splstr in line:

        sample_string = splstr[0:-1]
        words = sample_string.split(",")

    if len(words) > 2:

        #gyro x roll
        Gyro_Vector[0] = float(words[3])
        #gyro y pitch
        Gyro_Vector[1] = float(words[4])
        #gyro Z yaw
        Gyro_Vector[2] = float(words[5])

        Accel_Vector[0] = float(words[0])
        Accel_Vector[1] = float(words[1])
        Accel_Vector[2] = -float(words[2])

        #adding proportional term
        Omega = SommeVecteurs(Gyro_Vector, Omega_I)
        #adding Integrator term
        Omega_Vector = SommeVecteurs(Omega, Omega_P)

        G_Dt = time() - time_old
        time_old = time()
        G_Dt = 0.001

        Update_Matrix[0][0] = 0
        # -z
        Update_Matrix[0][1] = -G_Dt * Omega_Vector[2]
        # y
        Update_Matrix[0][2] = G_Dt * Omega_Vector[1]
        # z
        Update_Matrix[1][0] = G_Dt * Omega_Vector[2]
        Update_Matrix[1][1] = 0
        Update_Matrix[1][2] = -G_Dt * Omega_Vector[0]
        Update_Matrix[2][0] = -G_Dt * Omega_Vector[1]
        Update_Matrix[2][1] = G_Dt * Omega_Vector[0]
        Update_Matrix[2][2] = 0

        Temporary_Matrix = MultiplicationMatrices(DCM_Matrix, Update_Matrix)

        # Matrix Addition (update)
        for i in range(3):
            for j in range(3):
                DCM_Matrix[i][j] = DCM_Matrix[i][j] + Temporary_Matrix[i][j]

        error = -0.5 * ProduitScalaire(DCM_Matrix[0][:], DCM_Matrix[1][:])

        temp0 = ProduitVecteurParScalaire(DCM_Matrix[1][:], error)
        temp1 = ProduitVecteurParScalaire(DCM_Matrix[0][:], error)

        temp0 = SommeVecteurs(temp0, DCM_Matrix[0][:])
        temp1 = SommeVecteurs(temp1, DCM_Matrix[1][:])
        temp2 = ProduitVectoriel(temp0, temp1)

        renorm = .5 * (3 - ProduitScalaire(temp0, temp0))
        DCM0 = ProduitVecteurParScalaire(temp0, renorm)

        renorm = .5 * (3 - ProduitScalaire(temp1, temp1))
        DCM1 = ProduitVecteurParScalaire(temp1, renorm)

        renorm = .5 * (3 - ProduitScalaire(temp2, temp2))
        DCM2 = ProduitVecteurParScalaire(temp2, renorm)

        DCM_Matrix = [DCM0, DCM1, DCM2]

        # Calculate the magnitude of the accelerometer vector
        Accel_magnitude = sqrt(Accel_Vector[0] * Accel_Vector[0] + Accel_Vector[1] * Accel_Vector[1] + Accel_Vector[2] * Accel_Vector[2])
        # Scale to gravity.
        Accel_magnitude = Accel_magnitude / GRAVITY
        # Dynamic weighting of accelerometer info (reliability filter)
        # Weight for accelerometer info (<0.5G = 0.0, 1G = 1.0 , >1.5G = 0.0)
        Accel_weight = 1 - 2 * abs(1 - Accel_magnitude)
        if Accel_weight < 0:
            Accel_weight = 0
        elif Accel_weight > 1:
            Accel_weight = 1
        else:
            pass

        #adjust the ground of reference
        errorRollPitch = ProduitVectoriel(Accel_Vector, DCM_Matrix[2][:])
        Omega_P = ProduitVecteurParScalaire(errorRollPitch, Kp_ROLLPITCH * Accel_weight)
        Scaled_Omega_I = ProduitVecteurParScalaire(errorRollPitch, Ki_ROLLPITCH * Accel_weight)
        Omega_I = SommeVecteurs(Omega_I, Scaled_Omega_I)

        pitch = -asin(DCM_Matrix[2][0])
        roll = atan2(DCM_Matrix[2][1], DCM_Matrix[2][2])
        yaw = atan2(DCM_Matrix[1][0], DCM_Matrix[0][0])

        axis = (cos(pitch) * cos(yaw), -cos(pitch) * sin(yaw), sin(pitch))
        up = (sin(roll) * sin(yaw) + cos(roll) * sin(pitch) * cos(yaw), sin(roll) * cos(yaw) - cos(roll) * sin(pitch) * sin(yaw), -cos(roll) * cos(pitch))
        platform.axis = axis
        platform.up = up
        platform.length = 1.0
        platform.width = 0.6
        plat_arrow.axis = axis
        plat_arrow.up = up
        plat_arrow.length = 0.8
        p_line.axis = axis
        p_line.up = up
        cil_roll.axis = (0.2 * cos(-roll), 0.2 * sin(-roll), 0)
        cil_roll2.axis = (-0.2 * cos(-roll), -0.2 * sin(-roll), 0)
        cil_pitch.axis = (0.2 * cos(pitch), 0.2 * sin(pitch), 0)
        cil_pitch2.axis = (-0.2 * cos(pitch), -0.2 * sin(pitch), 0)
        arrow_course.axis = (0.2 * sin(yaw), 0.2 * cos(yaw), 0)
        L1.text = " %.2f" % roll
        L2.text = " %.2f" % pitch
        L3.text = " %.2f" % yaw


s.close()
